#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sgl+.h>

#define tmax 1000.
#define dt   0.1
#define x_init   0.15
#define y_init   0.85
#define r    0.02

int main(int argc, char *argv[])
{

  int i;
  float t,vx,vy;
  float x00,y00,r00;
  float x0 ,y0, r0 ;
  float x1 ,y1, x2 ,y2 ;
  float x_hat,y_hat, vx_hat,vy_hat;
  float x_star1, x_star2, x_star;
  float                   y_star;
  float A, a, b, c, D, sqrtD,dy;
  float theta, sin_2th,cos_2th;
  
  vx =  0.3, vy =  0.1;
  x00=0.5;y00=0.5,r00=0.5;
  x0 =0.3,y0 =0.5,r0 =0.2;
  x_star = y_star = 0;
  
  sgl_winsize(500,500);
  sgl_init();
  
  x1=x_init;y1=y_init;
  x2=x1;y2=y1;
  
  for(t=0;t<tmax;t+=dt)
  {
    x2 = x1 + vx*dt;
    y2 = y1 + vy*dt;

    if(x2<=0. || x2>=1. ) vx=-vx;
    if(y2<=0. || y2>=1. ) vy=-vy;

    printf("( %f , %f ) \n",x2,y2);

    if( (x2-x0)*(x2-x0)+(y2-y0)*(y2-y0) < r0*r0 )
    {
      A = vy / vx; dy = y1-y0;
      a = A*A +1.0;
      b = A*A*x1+x0-A*dy ;
      c = x0*x0+(A*x1-dy)*(A*x1-dy)-r0*r0;
      D = b*b - a*c;
      sqrtD =sqrt( D );
      x_star1 = ( b + sqrtD )/a;
      x_star2 = ( b - sqrtD )/a;

      if( (x_star1-x1)*(x_star1-x2) < 0 )
      {
	x_star = x_star1;
	printf("x_star1\n");
      }
      if( (x_star2-x1)*(x_star2-x2) < 0 )
      {
	x_star = x_star2;
	printf("x_star2\n");
      }
      if( (x_star1-x1)*(x_star1-x2) >0 && (x_star2-x1)*(x_star2-x2) > 0 )
      { 
	printf("Warning !!!!!!!!!!!!!!!!!!!!!!!!\n"); 
	printf("Warning !!!!!!!!!!!!!!!!!!!!!!!!\n"); 
	printf("Warning !!!!!!!!!!!!!!!!!!!!!!!!\n"); 
	printf("Warning !!!!!!!!!!!!!!!!!!!!!!!!\n"); 
	printf("Warning !!!!!!!!!!!!!!!!!!!!!!!!\n");
      }

      y_star = A*( x_star - x1 ) + y1;

      printf("a= %f \n",a);
      printf("D= %f \n",D);
      printf("b= %f \n",b);
      printf("x_star1 = %f x_star2 = %f \n",x_star1,x_star2); 
      printf("x_star = %f y_star = %f %f %f \n",x_star,y_star,x2,y2); 

      theta = atan( - (x_star-x0)/(y_star-y0) ) - atan( (y2-y1)/(x2-x1) ) ;

      printf("theta = %f \n",theta * 360 / 3.141592 );
      
      //printf("Please Input Return\n"); 
      //i=getchar();
      cos_2th = cos( 2.*theta );
      sin_2th = sin( 2.*theta );
      x_hat =   cos_2th * ( x2-x_star ) - sin_2th * (y2-y_star ) + x_star;
      y_hat =   sin_2th * ( x2-x_star ) + cos_2th * (y2-y_star ) + y_star;
      
      vx_hat =   cos_2th *  vx - sin_2th * vy ;
      vy_hat =   sin_2th *  vx + cos_2th * vy ;
      
      x2   = x_hat  ; y2  = y_hat ; 
      vx  = vx_hat ; vy = vy_hat ; 
    }
    x1   = x2      ; y1 = y2      ;
    
    sgl_disc(x1,y1,r);
    
    sgl_circle(x0,y0,r0);
    sgl_rectangle(0.0,0.01,0.99,0.99);
    sgl_display();
    
  }
  i=getchar();
}
