
/****************************************************************************/
/*                                                                          */
/*                          sample6: test_ps.c                              */
/*                                                                          */
/*   This is a sample program                                               */
/*   Maybe, You will understand how to use the function                     */
/*   "sgl_2D_scalar_field_to_PS()"                                          */
/*                                                                          */
/*                              Let's Try !                                 */
/*                                                  written by T.Taniguchi  */
/*                                                                          */
/****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sgl+.h"

#define tmax     3
#define Lx       100
#define Ly       100

int main(int argc, char *argv[])
{

  int i,j;
  int t;
  float Phi[Lx][Ly];
  sgl_winsize(Lx,Ly);
  sgl_init();
  sgl_color(SGL_BLACK); 
  sgl_color_background(SGL_BLACK);
  char filename[32];

  for(t=0;t<tmax;t++)
  {

    sprintf( filename, "testPSfile%d.ps",t );
    for(j=0;j<Ly;j++)
    {
      for(i=0;i<Lx;i++)
      {
	Phi[i][j]= ( 1.0 - 1.0/Lx*i )*0.3;
	printf("Phi[%3d][%3d]=%f\n ",i,j,Phi[i][j]);
      }
    }

    sgl_2D_scalar_field( *Phi, t );
    if( t < 2 ){
      sgl_2D_scalar_field_to_PS( *Phi , filename );
    }else{
      sgl_2D_scalar_field_to_PS( *Phi , filename, 1, 0.0, 0.3 );
    }

    sgl_display();

  }
  i=getchar();
}
